diff --git a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
similarity index 76%
rename from src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
rename to src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
index 6666bf4ef..6bf894b2a 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
+++ b/src/main/java/net/minecraft/client/gui/container/InventoryScreenCreative.java
@@ -1,9 +1,11 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.container;
 
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.client.gui.options.GuiOptionsButton;
+import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.CreativeInventoryMenu;
 import net.minecraft.client.render.Lighting;
@@ -13,19 +15,19 @@ import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
-import net.minecraft.client.gui.GuiTextField.ITextChangeListener;
+import net.minecraft.client.gui.TextFieldElement.ITextChangeListener;
 import org.lwjgl.opengl.GL12;
 
-public class GuiInventoryCreative extends GuiInventory implements ITextChangeListener
+public class InventoryScreenCreative extends InventoryScreen implements ITextChangeListener
 {
-	protected GuiButton lastPageButton;
-	protected GuiButton nextPageButton;
-	protected GuiOptionsButton clearSearchButton;
-	protected GuiTextField searchField;
+	protected ButtonElement lastPageButton;
+	protected ButtonElement nextPageButton;
+	protected OptionsButtonElement clearSearchButton;
+	protected TextFieldElement searchField;
 	protected CreativeInventoryMenu container;
 	protected String pageString = "1/1";
 	
-	public GuiInventoryCreative(Player entityplayer)
+	public InventoryScreenCreative(Player entityplayer)
 	{
 		super(entityplayer);
 		xSize = 298;
@@ -39,10 +41,10 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	public void init()
 	{
 		super.init();
-		controlList.add(lastPageButton = new GuiButton(500, 0, 0, 20, 20, "<"));
-		controlList.add(nextPageButton = new GuiButton(501, 0, 0, 20, 20, ">"));
-		controlList.add(clearSearchButton = new GuiOptionsButton(0, 0, 10, 12, 20, "X"));
-		searchField = new GuiTextField(this, fontRenderer, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
+		buttons.add(lastPageButton = new ButtonElement(500, 0, 0, 20, 20, "<"));
+		buttons.add(nextPageButton = new ButtonElement(501, 0, 0, 20, 20, ">"));
+		buttons.add(clearSearchButton = new OptionsButtonElement(0, 0, 10, 12, 20, "X"));
+		searchField = new TextFieldElement(this, font, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
 		searchField.drawBackground =false;
 		searchField.setMaxStringLength(14);
 		searchField.setTextChangeListener(this);
@@ -79,9 +81,9 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	}
 
 	@Override
-	public void onClosed()
+	public void removed()
 	{
-		super.onClosed();
+		super.removed();
 		Keyboard.enableRepeatEvents(false);
 	}
 
@@ -94,9 +96,9 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	}
 	
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
-		super.buttonPressed(button);
+		super.buttonClicked(button);
     	if (!button.enabled)
     	{
     		return;
@@ -131,28 +133,28 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	
     
     @Override
-	public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+	public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
-        searchField.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
+        searchField.mouseClicked(mx, my, buttonNum);
     }
     
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-    	if (searchField.isFocused && i != Keyboard.KEY_ESCAPE)
+    	if (searchField.isFocused && eventKey != Keyboard.KEY_ESCAPE)
     	{
-    		searchField.textboxKeyTyped(c, i);
+    		searchField.textboxKeyTyped(eventCharacter, eventKey);
     		container.searchPage(searchField.getText());
     		updatePageSwitcher();
     	}
-    	else if (!searchField.isFocused && c == 't')
+    	else if (!searchField.isFocused && eventCharacter == 't')
     	{
     		searchField.setFocused(true);
     	}
     	else
     	{
-    		super.keyTyped(c, i, mouseX, mouseY);    		
+    		super.keyPressed(eventCharacter, eventKey, mx, my);
     	}
     }
     
@@ -160,7 +162,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	protected void drawGuiContainerForegroundLayer()
     {
     	super.drawGuiContainerForegroundLayer();
-    	drawStringCenteredNoShadow(fontRenderer, pageString, 238, 146, 0x404040);
+    	drawStringCenteredNoShadow(font, pageString, 238, 146, 0x404040);
     }
 	
     @Override
@@ -169,7 +171,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 		scroll(Mouse.getDWheel());
 
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-		mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/creative.png").bind();
+		mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/creative.png").bind();
         int x = (width - xSize) / 2;
         int y = (height - ySize) / 2;
         lastPageButton.xPosition = x + 182;
@@ -216,7 +218,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
     }
 
 	@Override
-    public void textChanged(GuiTextField textField) {
+    public void textChanged(TextFieldElement textField) {
 		container.searchPage(textField.getText());
 		updatePageSwitcher();
 	}
diff --git a/src/main/java/net/minecraft/client/gui/GuiTrommel.java b/src/main/java/net/minecraft/client/gui/container/TrommelScreen.java
similarity index 73%
rename from src/main/java/net/minecraft/client/gui/GuiTrommel.java
rename to src/main/java/net/minecraft/client/gui/container/TrommelScreen.java
index 76e24e647..a8fa756ff 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTrommel.java
+++ b/src/main/java/net/minecraft/client/gui/container/TrommelScreen.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.container;
 
 import net.minecraft.core.block.entity.TrommelBlockEntity;
 import net.minecraft.core.lang.I18n;
@@ -10,10 +10,10 @@ import org.lwjgl.opengl.GL11;
 //            GuiContainer, ContainerFurnace, FontRenderer, RenderEngine,
 //            FurnaceBlockEntity, InventoryPlayer
 
-public class GuiTrommel extends GuiContainer
+public class TrommelScreen extends AbstractContainerScreen
 {
 
-    public GuiTrommel(Inventory inventoryplayer, TrommelBlockEntity tileentitytrommel)
+    public TrommelScreen(Inventory inventoryplayer, TrommelBlockEntity tileentitytrommel)
     {
         super(new TrommelMenu(inventoryplayer, tileentitytrommel));
         ySize = 192;
@@ -23,15 +23,15 @@ public class GuiTrommel extends GuiContainer
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-            fontRenderer.drawString(I18n.getInstance().translateKey("gui.trommel.label.trommel"), 60, 6, 0x404040);
-        fontRenderer.drawString(I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+            font.drawString(I18n.getInstance().translateKey("gui.trommel.label.trommel"), 60, 6, 0x404040);
+        font.drawString(I18n.getInstance().translateKey("gui.trommel.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/trommel.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/trommel.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
diff --git a/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
index 34e983b56..2bf5c0d93 100644
--- a/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.createworld;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.paged.PageComponent;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -20,12 +20,12 @@ public abstract class ButtonComponent
 
     private final String translationKey;
 
-    protected final GuiButton resetButton;
+    protected final ButtonElement resetButton;
 
     public ButtonComponent(String translationKey)
     {
         this.translationKey = translationKey;
-        this.resetButton = new GuiButton(0, 0, 0, 20, 20, "")
+        this.resetButton = new ButtonElement(0, 0, 0, 20, 20, "")
             .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
     }
 
@@ -42,7 +42,7 @@ public abstract class ButtonComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        FontRenderer fr = mc.fontRenderer;
+        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
diff --git a/src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldScreen.java
similarity index 66%
rename from src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java
rename to src/main/java/net/minecraft/client/gui/createworld/CreateWorldScreen.java
index fc852217c..1d7a97662 100644
--- a/src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java
+++ b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldScreen.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.gui.createworld;
 
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.paged.GuiPaged;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.paged.PagedScreen;
 
-public class GuiCreateWorld
-    extends GuiPaged {
-    public GuiCreateWorld(GuiScreen parent) {
+public class CreateWorldScreen
+    extends PagedScreen {
+    public CreateWorldScreen(Screen parent) {
         super(
             parent,
             CreateWorldPageRegistry.getInstance(),
diff --git a/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java b/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
index 8aff0bfd9..eaad53240 100644
--- a/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
+++ b/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
@@ -1,15 +1,12 @@
 package net.minecraft.client.gui.createworld;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiTextField;
-import net.minecraft.client.gui.GuiTexturedButton;
+import net.minecraft.client.gui.TextFieldElement;
 import net.minecraft.client.gui.paged.CallbackComponent;
 import net.minecraft.client.gui.paged.OnValueChangedCallback;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -24,7 +21,7 @@ public class TextFieldComponent
 
     private final String translationKey;
 
-    private final GuiTextField textField;
+    private final TextFieldElement textField;
 
     private OnValueChangedCallback<String> callback = null;
 
@@ -32,9 +29,9 @@ public class TextFieldComponent
     {
         this.translationKey = translationKey;
 
-        this.textField = new GuiTextField(
+        this.textField = new TextFieldElement(
             null,
-            mc.fontRenderer,
+            mc.font,
             0, 0,
             BUTTON_WIDTH,
             18,
@@ -52,7 +49,7 @@ public class TextFieldComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        FontRenderer fr = mc.fontRenderer;
+        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
index e3bad2858..08e74cfb9 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.guidebook;
 
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import org.lwjgl.opengl.GL11;
 
 public abstract class GuidebookPage
@@ -19,24 +19,24 @@ public abstract class GuidebookPage
         return this.section;
     }
 
-    protected void renderBackground(RenderEngine re, int x, int y) {
+    protected void renderBackground(TextureManager re, int x, int y) {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         drawTexturedModalRect(x, y, 0, 0, width, height);
     }
 
-    protected abstract void renderForeground(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks);
+    protected abstract void renderForeground(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks);
 
     public boolean drawHeaders() {
         return true;
     }
 
-    public void render(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
+    public void render(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         renderBackground(re, x, y);
         renderForeground(re, fr, x, y, mouseX, mouseY, partialTicks);
     }
 
-    protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) { };
+    protected void renderOverlay(TextureManager re, Font fr, int x, int y, int mouseX, int mouseY, float partialTicks) { };
 
     public void onMouseDown(int x, int y, int mouseX, int mouseY, int button) { }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
similarity index 82%
rename from src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
rename to src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
index e78e5077d..0bf98c479 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
@@ -2,15 +2,15 @@ package net.minecraft.client.gui.guidebook;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.GuiTooltip;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.gui.guidebook.search.SearchSection;
 import net.minecraft.client.input.controller.ControllerInput;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.OpenGLHelper;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -26,8 +26,8 @@ import org.lwjgl.opengl.GL12;
 import java.util.List;
 import java.util.Random;
 
-public class GuiGuidebook
-    extends GuiScreen {
+public class GuidebookScreen
+    extends Screen {
     private static final int TABS_PER_SIDE = 8;
     private static PageManager pageManager = null;
     public static PageManager getPageManager() {
@@ -40,13 +40,13 @@ public class GuiGuidebook
 
     private final int xSize = 158 * 2;
     private final int ySize = 220;
-    private final GuiTooltip tooltip = new GuiTooltip(Minecraft.getMinecraft(this));
+    private final TooltipElement tooltip = new TooltipElement(Minecraft.getMinecraft(this));
     private Tab[] tabs = new Tab[TABS_PER_SIDE * 2];
 
     private GuidebookPage lastPage = null;
     private boolean canPlaySound = true;
 
-    public GuiGuidebook() {
+    public GuidebookScreen() {
         super();
 
         getPageManager();
@@ -61,8 +61,8 @@ public class GuiGuidebook
     }
 
     @Override
-    public void onClosed() {
-        super.onClosed();
+    public void removed() {
+        super.removed();
 
         Keyboard.enableRepeatEvents(false);
     }
@@ -136,12 +136,12 @@ public class GuiGuidebook
     }
 
     @Override
-    public boolean pausesGame() {
+    public boolean isPauseScreen() {
         return false;
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float renderPartialTicks) {
+    public void render(int xm, int ym, float renderPartialTicks) {
         lastPage = pageManager.getLeftPage();
         scroll(Mouse.getDWheel());
 
@@ -153,13 +153,13 @@ public class GuiGuidebook
             xOffset = 158 / 2;
         }
 
-        drawDefaultBackground();
-        drawTabs(mouseX, mouseY);
-        drawCurrentPages(mouseX, mouseY, xOffset, renderPartialTicks);
+        renderBackground();
+        drawTabs(xm, ym);
+        drawCurrentPages(xm, ym, xOffset, renderPartialTicks);
         drawHeaders(xOffset);
-        drawCurrentPageOverlays(mouseX,mouseY,xOffset,renderPartialTicks);
-        drawPageTurnIndicator(mouseX, mouseY, xOffset);
-        drawTooltip(mouseX, mouseY);
+        drawCurrentPageOverlays(xm, ym,xOffset,renderPartialTicks);
+        drawPageTurnIndicator(xm, ym, xOffset);
+        drawTooltip(xm, ym);
     }
 
     private void scroll(int direction) {
@@ -177,17 +177,17 @@ public class GuiGuidebook
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        super.mouseClicked(mx, my, buttonNum);
 
         // Handle back button
-        if (mouseButton == 3) {
+        if (buttonNum == 3) {
             pageManager.goBack();
             playPageSound();
             updateTabList();
             return;
         }
-        if (mouseButton == 4) {
+        if (buttonNum == 4) {
             pageManager.goForward();
             playPageSound();
             updateTabList();
@@ -210,13 +210,13 @@ public class GuiGuidebook
         int right = width / 2 + xSize / 2 + xOffset;
 
         if (pageManager.getLeftPage() != null && pageManager.hasPreviousPage()) {
-            if (mouseX >= left && mouseX <= left + size && mouseY >= top && mouseY <= top + size) {
+            if (mx >= left && mx <= left + size && my >= top && my <= top + size) {
                 pageManager.offsetPage(-2);
                 playPageSound();
                 updateTabList();
                 return;
             }
-            if (mouseX >= left && mouseX <= left + size && mouseY >= bottom - size && mouseY <= bottom) {
+            if (mx >= left && mx <= left + size && my >= bottom - size && my <= bottom) {
                 pageManager.offsetPage(-2);
                 playPageSound();
                 updateTabList();
@@ -224,13 +224,13 @@ public class GuiGuidebook
             }
         }
         if (pageManager.getRightPage() != null && pageManager.hasNextPage()) {
-            if (mouseX >= right - size && mouseX <= right && mouseY >= top && mouseY <= top + size) {
+            if (mx >= right - size && mx <= right && my >= top && my <= top + size) {
                 pageManager.offsetPage(2);
                 playPageSound();
                 updateTabList();
                 return;
             }
-            if (mouseX >= right - size && mouseX <= right && mouseY >= bottom - size && mouseY <= bottom) {
+            if (mx >= right - size && mx <= right && my >= bottom - size && my <= bottom) {
                 pageManager.offsetPage(2);
                 playPageSound();
                 updateTabList();
@@ -238,23 +238,23 @@ public class GuiGuidebook
             }
         }
 
-        if (pageManager.getLeftPage() != null && mouseX > left && mouseX < left + xSize / 2 && mouseY > top && mouseY < bottom) {
-            pageManager.getLeftPage().onMouseDown(left, top, mouseX, mouseY, mouseButton);
+        if (pageManager.getLeftPage() != null && mx > left && mx < left + xSize / 2 && my > top && my < bottom) {
+            pageManager.getLeftPage().onMouseDown(left, top, mx, my, buttonNum);
             updateTabList();
             return;
         }
-        if (pageManager.getRightPage() != null && mouseX > left + xSize / 2 && mouseX < right && mouseY > top && mouseY < bottom) {
-            pageManager.getRightPage().onMouseDown(left + xSize / 2, top, mouseX, mouseY, mouseButton);
+        if (pageManager.getRightPage() != null && mx > left + xSize / 2 && mx < right && my > top && my < bottom) {
+            pageManager.getRightPage().onMouseDown(left + xSize / 2, top, mx, my, buttonNum);
             updateTabList();
             return;
         }
 
-        handleTabClicks(mouseX, mouseY);
+        handleTabClicks(mx, my);
     }
 
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY) {
-        if(key != Keyboard.KEY_BACK) super.keyTyped(c, key, mouseX, mouseY);
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if(eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
 
         int xOffset = 0;
         if (pageManager.getLeftPage() == null) {
@@ -268,22 +268,22 @@ public class GuiGuidebook
         int left = width / 2 - xSize / 2 + xOffset;
 
         if (allowArrowKeyNavigation) {
-            if (key == Keyboard.KEY_LEFT) {
+            if (eventKey == Keyboard.KEY_LEFT) {
                 pageManager.offsetPage(-2);
                 updateTabList();
             }
-            if (key == Keyboard.KEY_RIGHT) {
+            if (eventKey == Keyboard.KEY_RIGHT) {
                 pageManager.offsetPage(2);
                 updateTabList();
             }
         }
 
         if (pageManager.getLeftPage() != null) {
-            pageManager.getLeftPage().keyTyped(c, key, left, top, mouseX, mouseY);
+            pageManager.getLeftPage().keyTyped(eventCharacter, eventKey, left, top, mx, my);
             updateTabList();
         }
         if (pageManager.getRightPage() != null) {
-            pageManager.getRightPage().keyTyped(c, key, left + xSize / 2, top, mouseX, mouseY);
+            pageManager.getRightPage().keyTyped(eventCharacter, eventKey, left + xSize / 2, top, mx, my);
             updateTabList();
         }
     }
@@ -383,7 +383,7 @@ public class GuiGuidebook
     private void drawTabs(int mouseX, int mouseY) {
         for (Tab tab : tabs) {
             if (tab == null) break;
-            tab.render(mc.renderEngine, mc.fontRenderer, mouseX, mouseY);
+            tab.render(mc.textureManager, mc.font, mouseX, mouseY);
         }
     }
 
@@ -406,10 +406,10 @@ public class GuiGuidebook
         GuidebookPage rightPage = pageManager.getRightPage();
 
         if (leftPage != null) {
-            leftPage.render(mc.renderEngine, mc.fontRenderer, left, top, mouseX, mouseY, partialTicks);
+            leftPage.render(mc.textureManager, mc.font, left, top, mouseX, mouseY, partialTicks);
         }
         if (rightPage != null) {
-            rightPage.render(mc.renderEngine, mc.fontRenderer, right - 158, top, mouseX, mouseY, partialTicks);
+            rightPage.render(mc.textureManager, mc.font, right - 158, top, mouseX, mouseY, partialTicks);
         }
     }
 
@@ -423,10 +423,10 @@ public class GuiGuidebook
         GuidebookPage rightPage = pageManager.getRightPage();
 
         if (leftPage != null) {
-            leftPage.renderOverlay(mc.renderEngine, mc.fontRenderer,left,top,mouseX,mouseY,partialTicks);
+            leftPage.renderOverlay(mc.textureManager, mc.font,left,top,mouseX,mouseY,partialTicks);
         }
         if (rightPage != null) {
-            rightPage.renderOverlay(mc.renderEngine, mc.fontRenderer,right - 158,top,mouseX,mouseY,partialTicks);
+            rightPage.renderOverlay(mc.textureManager, mc.font,right - 158,top,mouseX,mouseY,partialTicks);
         }
     }
 
@@ -440,13 +440,13 @@ public class GuiGuidebook
 
         //find a way how to display the total number of pages properly maybe
         if (leftPage != null && leftPage.drawHeaders()) {
-            drawStringNoShadow(fontRenderer, String.valueOf(pageManager.getPageIndex(leftPage)) /*+ "/" + pageManager.getNumPages()*/, left + 12, bottom - 20, 0xFF000000);
-            drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey(pageManager.getLeftPage().getSection().getTranslationKey()), left + 158 / 2, bottom - 20, 0xFF808080);
+            drawStringNoShadow(font, String.valueOf(pageManager.getPageIndex(leftPage)) /*+ "/" + pageManager.getNumPages()*/, left + 12, bottom - 20, 0xFF000000);
+            drawStringCenteredNoShadow(font, I18n.getInstance().translateKey(pageManager.getLeftPage().getSection().getTranslationKey()), left + 158 / 2, bottom - 20, 0xFF808080);
         }
         if (rightPage != null && rightPage.drawHeaders()) {
             String str = String.valueOf(pageManager.getPageIndex(rightPage)); /*+ "/" + pageManager.getNumPages();*/
-            drawStringNoShadow(fontRenderer, str, right - 12 - fontRenderer.getStringWidth(str), bottom - 20, 0xFF000000);
-            drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey(pageManager.getRightPage().getSection().getTranslationKey()), right - 158 / 2, bottom - 20, 0xFF808080);
+            drawStringNoShadow(font, str, right - 12 - font.getStringWidth(str), bottom - 20, 0xFF000000);
+            drawStringCenteredNoShadow(font, I18n.getInstance().translateKey(pageManager.getRightPage().getSection().getTranslationKey()), right - 158 / 2, bottom - 20, 0xFF808080);
         }
     }
 
@@ -458,7 +458,7 @@ public class GuiGuidebook
         int left = width / 2 - xSize / 2 + xOffset;
         int right = width / 2 + xSize / 2 + xOffset;
 
-        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
+        mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
 
         GL11.glColor4f(1, 1, 1, 1);
         if (pageManager.getLeftPage() != null && pageManager.hasPreviousPage()) {
@@ -514,7 +514,7 @@ public class GuiGuidebook
             this.active = active;
         }
 
-        public void render(RenderEngine re, FontRenderer fr, int mouseX, int mouseY) {
+        public void render(TextureManager re, Font fr, int mouseX, int mouseY) {
             boolean mouseOver = mouseOver(mouseX, mouseY);
 
             re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
@@ -559,7 +559,7 @@ public class GuiGuidebook
             }
         }
 
-        public void renderTooltip(GuiTooltip tooltip, int mouseX, int mouseY) {
+        public void renderTooltip(TooltipElement tooltip, int mouseX, int mouseY) {
             if (mouseOver(mouseX, mouseY)) {
                 tooltip.render(I18n.getInstance().translateKey(section.getTranslationKey()), mouseX, mouseY, 8, -8);
             }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java b/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
index 82071ad91..68aa577a0 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
@@ -1,8 +1,12 @@
 package net.minecraft.client.gui.guidebook;
 
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+
 import java.util.Stack;
 
 public class PageNavigationStack {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final int maxSize;
     private final Stack<Integer> stack = new Stack<>();
     private int stackPointer = 0;
@@ -45,12 +49,12 @@ public class PageNavigationStack {
 
     public void goBack() {
         decSP();
-        System.out.println(stackPointer + "/" + (stack.size() - 1));
+        LOGGER.debug("{}/{}", stackPointer, stack.size() - 1);
     }
 
     public void goForward() {
         incSP();
-        System.out.println(stackPointer + "/" + (stack.size() - 1));
+        LOGGER.debug("{}/{}", stackPointer, stack.size() - 1);
     }
 
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/RecipePage.java b/src/main/java/net/minecraft/client/gui/guidebook/RecipePage.java
index 8014bd6ee..f34b35f32 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/RecipePage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/RecipePage.java
@@ -1,9 +1,6 @@
 package net.minecraft.client.gui.guidebook;
 
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 
 import java.util.List;
 
